<?php
defined('_JEXEC') or die('Restricted access');

class PlgSystemAutologin extends JPlugin
{
    var $username;
    var $password;

    function __construct(& $subject, $config){
        parent::__construct($subject, $config);
        include_once(rtrim(JPATH_ADMINISTRATOR,DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_acymailing'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'helper.php');
        $this->loadLanguage();
    }

    function onAfterInitialise(){
        $this->username = acymailing_getVar('none', 'user', null);
        $this->password = acymailing_getVar('none', 'passw', null);

        if(empty($this->username) || empty($this->password)) return true;

        $result = $this->params->get('authmethod','1') === '0' ? $this->plainLogin() : $this->encryptLogin();

        $redirectURL = $this->params->get('urlredirect', null);
        if(!empty($redirectURL)){
            if(!($result instanceof Exception)){
                acymailing_redirect($redirectURL);
            }
        }
    }
    
    function plainLogin(){
        $app = JFactory::getApplication();

        $credentials = array();
        $credentials['username'] = $this->username;
        $credentials['password'] = $this->password;

        $options = array();
        $result = $app->login($credentials, $options);
        if(!$result){
            $credentials['username'] = urldecode($this->username);
            $credentials['password'] = urldecode($this->password);
            $result = $app->login($credentials, $options);
        }

        return $result;
    }

    function encryptLogin(){
        $result = acymailing_loadObject('SELECT `id`, `username`, `password` FROM `#__users` WHERE username = '.acymailing_escapeDB($this->username).' AND password='.acymailing_escapeDB($this->password));
        if(!$result) {
            $result = acymailing_loadObject('SELECT `id`, `username`, `password` FROM `#__users` WHERE username = '.acymailing_escapeDB(urldecode($this->username)).' AND password='.acymailing_escapeDB(urldecode($this->password)));
        }

        if($result) {
            acymailing_importPlugin('user');

            $options = array();
            $options['action'] = 'core.login.site';

            $response['username'] = $result->username;
            $result = acymailing_trigger('onUserLogin', array((array)$response, $options));
        }
    }
}